

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>CNN &mdash; SmartRecruiting back v2 documentation</title>
  

  
  
  
  

  
  <script type="text/javascript" src="../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
        <script type="text/javascript" src="../_static/jquery.js"></script>
        <script type="text/javascript" src="../_static/underscore.js"></script>
        <script type="text/javascript" src="../_static/doctools.js"></script>
        <script type="text/javascript" src="../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Data" href="data.html" />
    <link rel="prev" title="Preprocess" href="preprocess.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../index.html" class="icon icon-home"> SmartRecruiting back
          

          
          </a>

          
            
            
              <div class="version">
                v2
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../install.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../contributing.html">Contributing</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../documentation.html">Backend documentation</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="deeplearning.html">Deeplearning</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="preprocess.html">Preprocess</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">CNN</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#introduction">Introduction</a></li>
<li class="toctree-l4"><a class="reference internal" href="#todo">TODO</a></li>
<li class="toctree-l4"><a class="reference internal" href="#code-documentation">Code documentation</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="data.html">Data</a></li>
<li class="toctree-l2"><a class="reference internal" href="api.html">API</a></li>
</ul>
</li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">SmartRecruiting back</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../documentation.html">Backend documentation</a> &raquo;</li>
        
          <li><a href="deeplearning.html">Deeplearning</a> &raquo;</li>
        
      <li>CNN</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../_sources/backend_doc/cnn.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="module-SmartRecruiting_BackEnd.deeplearning.cnn">
<span id="cnn"></span><h1>CNN<a class="headerlink" href="#module-SmartRecruiting_BackEnd.deeplearning.cnn" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>This module handle the Keras model to predict formation from an offer.</p>
<p>The class Model defined our Keras model and its methods (train, eval, predict, etc).</p>
<p>The file <code class="docutils literal notranslate"><span class="pre">train.py</span></code> create and train this model. So it’s composed mainly of 1 file to load offers and
split them to train and eval the model.</p>
</div>
<div class="section" id="todo">
<h2>TODO<a class="headerlink" href="#todo" title="Permalink to this headline">¶</a></h2>
<p>It’s difficult to choose the model’s layers and parameters. So create a file to see the impacts of the model adjustment
is an interesting improvement :</p>
<ul class="simple">
<li>graph f(epoch) = accuracy or loss , to adjust epoch parameter</li>
<li>keep in a file all Model summary (can easily be found with keras) and results associated (accuracy, loss) to keep the history of models and their performances</li>
</ul>
</div>
<div class="section" id="code-documentation">
<h2>Code documentation<a class="headerlink" href="#code-documentation" title="Permalink to this headline">¶</a></h2>
<div class="section" id="module-SmartRecruiting_BackEnd.deeplearning.cnn.train">
<span id="train-py"></span><h3><code class="docutils literal notranslate"><span class="pre">train.py</span></code><a class="headerlink" href="#module-SmartRecruiting_BackEnd.deeplearning.cnn.train" title="Permalink to this headline">¶</a></h3>
<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.cnn.train.get_offers">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.cnn.train.</code><code class="descname">get_offers</code><span class="sig-paren">(</span><em>db_manager</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/cnn/train.html#get_offers"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.cnn.train.get_offers" title="Permalink to this definition">¶</a></dt>
<dd><table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Returns:</th><td class="field-body">list of offers preprocess (str with stemmed word not in stop list)</td>
</tr>
<tr class="field-even field"><th class="field-name">Return type:</th><td class="field-body">(list of str, list of int)</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="SmartRecruiting_BackEnd.deeplearning.cnn.train.train">
<code class="descclassname">SmartRecruiting_BackEnd.deeplearning.cnn.train.</code><code class="descname">train</code><span class="sig-paren">(</span><em>db_manager</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/cnn/train.html#train"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.cnn.train.train" title="Permalink to this definition">¶</a></dt>
<dd><p>Train a convolutional neuronal network and save it in a file in /runs</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Param:</th><td class="field-body">the database manager</td>
</tr>
</tbody>
</table>
</dd></dl>

</div>
<div class="section" id="module-SmartRecruiting_BackEnd.deeplearning.cnn.Model">
<span id="model-py"></span><h3><code class="docutils literal notranslate"><span class="pre">Model.py</span></code><a class="headerlink" href="#module-SmartRecruiting_BackEnd.deeplearning.cnn.Model" title="Permalink to this headline">¶</a></h3>
<dl class="class">
<dt id="SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model">
<em class="property">class </em><code class="descclassname">SmartRecruiting_BackEnd.deeplearning.cnn.Model.</code><code class="descname">Model</code><span class="sig-paren">(</span><em>save_dirname</em>, <em>word2vec</em>, <em>epochs</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/cnn/Model.html#Model"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model" title="Permalink to this definition">¶</a></dt>
<dd><p>Handle a Keras model. Several public methods (see method documentation to know more how to use) :</p>
<ul class="simple">
<li>load : load the model from the directory [save_dirname]</li>
<li>build : generate the Keras model structure (layers)</li>
<li>train : train the Keras model</li>
<li>eval : eval the Keras model</li>
<li>predict : generate predictions for an offer</li>
</ul>
<dl class="method">
<dt id="SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.build">
<code class="descname">build</code><span class="sig-paren">(</span><em>number_of_labels</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/cnn/Model.html#Model.build"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.build" title="Permalink to this definition">¶</a></dt>
<dd><p>Build the Keras model structure (define the layers in our model)
It’s a multi-class classification, so the output are defined by [number_of_labels] parameter.</p>
<div class="admonition warning">
<p class="first admonition-title">Warning</p>
<p class="last">It’s probably the most important methods to change to improve the model.
The most “difficult” part is to find which layers to use and define layers parameters.</p>
</div>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>number_of_labels</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.7)"><em>int</em></a>) – output dimensions,</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.eval">
<code class="descname">eval</code><span class="sig-paren">(</span><em>features</em>, <em>labels</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/cnn/Model.html#Model.eval"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.eval" title="Permalink to this definition">¶</a></dt>
<dd><p>Eval the accuracy and the loss of our model with [features] (and check the results with [labels]</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>features</strong> (<em>list of str</em>) – features on which evaluate the model</li>
<li><strong>labels</strong> (<em>numpy array of numpy array of int</em><em> (</em><em>0</em><em> or </em><em>1</em><em>)</em>) – array of hot vector that represent formation associated with features
So array of the same size of features lists. And each element is an hot vector</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.load">
<code class="descname">load</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/cnn/Model.html#Model.load"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.load" title="Permalink to this definition">¶</a></dt>
<dd><p>Load the model (and so init the model parameter) from the specified directory (see class parameters)</p>
</dd></dl>

<dl class="method">
<dt id="SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.predict">
<code class="descname">predict</code><span class="sig-paren">(</span><em>feature</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/cnn/Model.html#Model.predict"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.predict" title="Permalink to this definition">¶</a></dt>
<dd><p>Predict formations of the [feature]</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>feature</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#str" title="(in Python v3.7)"><em>str</em></a>) – offer to predict</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body">dictionary of prediction {id_prediction: accuracy of the formation (mark)}</td>
</tr>
<tr class="field-odd field"><th class="field-name">Return type:</th><td class="field-body">dict {int : int}</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.train">
<code class="descname">train</code><span class="sig-paren">(</span><em>features</em>, <em>labels</em>, <em>save=True</em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/SmartRecruiting_BackEnd/deeplearning/cnn/Model.html#Model.train"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#SmartRecruiting_BackEnd.deeplearning.cnn.Model.Model.train" title="Permalink to this definition">¶</a></dt>
<dd><p>Train the Keras model with [features] and [label].</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first last simple">
<li><strong>features</strong> (<em>list of str</em>) – features on which train the model</li>
<li><strong>labels</strong> (<em>numpy array of numpy array of int</em><em> (</em><em>0</em><em> or </em><em>1</em><em>)</em>) – array of hot vector that represent formation associated with features
So array of the same size of features lists. And each element is an hot vector</li>
<li><strong>save</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.7)"><em>bool</em></a>) – set to True to save the model (saved in the directory specify in the class parameters)</li>
</ul>
</td>
</tr>
</tbody>
</table>
</dd></dl>

</dd></dl>

</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="data.html" class="btn btn-neutral float-right" title="Data" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="preprocess.html" class="btn btn-neutral float-left" title="Preprocess" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, Projet 21

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>